<?php
$ChangeLog = "
1.00.03     2008/05/29   Change \$Usage output informations
1.00.02     2008/05/28   Add Log dump function
";
$ReadMe = "
 DBTools                     Version 1.00.03     2008/05/29
 Copyright by Pedro P. Wong.
                        
                distributable under the GNU GPL.
                http://www.gnu.org/licenses/licenses.html#GPL

 Base on ADOdb(a cross Database library), DBTools provides
 a standard command-file interface for DataBases access.
 It provides you a cross O.S. and DataBases platform solution.

 The first command line must be the discription of source Data
 Base informations. It means the source must be a Data Base.
 And the destination may be a file in CSV,HTML,SQL format or
 another Data Base. In case of DBTYPE = ODBC, the Data Base
 can be a commercial/open source Data Base or a Excel/CSV/Txt
 file.

 All the SQL command will access with source Data Base. In case
 of Select SQL command, the data will copy to the output file
 or destination Data Base.

";

$Usage="Use:DBTools [-n|N] [-D|d] [-i|I] ini_file [output_file] [log_file]
 		
  ini_file:         Data base script file name.
  output_file:      Data output file name
  log_file:         Log file name
  -N|n              sql_dump_flag means dump D.B. structure only.
  -D|d              Drop and create the table before D.B. data copy.
  -I|i              Use Insert SQL command for D.B. data copy.
                    default will use update command.

    ini_file commands:
   	1:First character less than 'A' will treat as a comment line.
  	2:The first command line must discribe the Data Base source.
          DataBase Infomations Format: Key-Word1=Value1;Key-Word2=Value2;...
                                   or: Value1;Key-Word2=Value2;...
          *In case of first key-word was absent, value1 will be treated
           as DBTYPE value.
          Following are Data Base Infomations Key-Words:
             DBTYPE=type          Define D.B. type.(Type define by ADOdb)
                                  (must be first parameter for D.B. Info.)
                                  Ex.ODBC,MySQL,MSSQL...
             SERVER=address       Define Srrver location(IP address).
             URL=address          Define Srrver location(IP address).
             USER=user_name       Define User name.
             PW=Pass_Word         Define Pass Word.
             PWD=Pass_Word        Define Pass Word.
             PASS=Pass_Word       Define Pass Word.
             PassWord=Pass_Word   Define Pass Word.
             DATABASE=D.B._name   Define Data Base Name
             SID=sid              Define SID for Oracle Data Base.
          More  Key-Word for DBTYPE=ODBC:
             UID=User_ID/UserName Define User ID or Name.
             DBA=W                Open Data Base in write mode.
             DBQ=D.B.File_Name    Define Data Base file name.
             DEFAULTDIR=Dir.      Define default Dir.
             DRIVER=Driver        Define ODBC Driver Name.
             FILEDSN|DSN=DSN_Name Define DSN file Name.
             PORT=Port_Number     Define port number.
   	3:Next may use EXCELBDBOutBHTML or standard SQL commands....
    4:HTML--Define Select output will dump in HTML format.
          HTML[;ztab][;specialchars]
             ztab                 Define tab value, default = 'BORDER=2'
             specialchars         Run htmlspecialchars? [true|false]
    5:EXCEL--Define Select output will insert into EXECL file.
  		  EXCEL xls_file_name Sheet_name
    6:DBOut--Copy Select output to This Data Base.
          DBOut;D.B.Info;Insert/Update/Drop DataBaseName KeyName
             'D.B.Info' same as 2:
             Insert/Update/Drop:
                Insert/Update:Use Insert or Update command for data copy.
                   *For Excel only insert mode.
  		        Drop:Drop and create the Table before data copy.
             DataBaseName:Define the Destination Data Base Name.
  		     KeyName: Key column name for Update SQL command.
    7:ListDBTables--List all Tables & Column names in the Data Base.
          ListDBTables
    8:DataBase--Define Source Data Base Name.
          DataBase DataBaseName
             DataBaseName:Define the Source Data Base Name.

  	SQL Select command causes data dump, so HTML/EXCEL/DBOut commands
  	must present previous and effect on next Select commands.
  	

  	Log will keep in log_file if specified.
  	
>";

include_once('DBFunctions.php');
include_once('.\ADOdb\tohtml.inc.php');

  $debug = 0;
  $Enc   = 0;
  
  $InName  = "";
  $OutName = "";
  $LogName = "";
  $Drop = 0;
  $N0Data = 0;
  $UseInsert = 0;
  $HTML = 0;
  $CSV = 1;
  $SQL = 0;
  $DBOut = "";
  $SubName="CSV";

  // D.B Input default value
  $DBType="ODBC";
  $URL='';
  $user='Administrator';
  $pw='';
  $DataBase='';
  $SID='';

  // D.B. Output default value
  $OutDBType="ODBC";
  $OutURL='';
  $Outuser='Administrator';
  $Outpw='';
  $OutDataBase='';
  $OutSID='';
  $OutKey='';

  // HTML default value
  $ztab = 'BORDER=2';
  $specialchars = true;


  // Input parameters process

 if ($argc==1) {
 		echo "No parameters error\n";
 		print $ReadMe;
	    print $Usage;

 		$fp = fopen("php://stdin", "r");
		$I = fgetc($fp);
		fclose ($fp);
 		exit();
 }
/*
 if (!extension_loaded('mssql')) {
    if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
        dl('php_mssql.dll');
        echo "Load php_mssql.dll\n";
    } else {
        dl('mssql.so');
        echo "Load php_mssql.so\n";
    }
 }
*/


if (!function_exists('fputcsv')) {

  function fputcsv(&$handle, $fields = array(), $delimiter = ',', $enclosure = '"')
  {
    $str = '';
    $escape_char = '\\';
    foreach ($fields as $value)
    {
      if (strpos($value, $delimiter) !== false ||
          strpos($value, $enclosure) !== false ||
          strpos($value, "\n") !== false ||
          strpos($value, "\r") !== false ||
          strpos($value, "\t") !== false ||
          strpos($value, ' ') !== false)
      {
        $str2 = $enclosure;
        $escaped = 0;
        $len = strlen($value);
        for ($i=0;$i<$len;$i++)
        {
          if ($value[$i] == $escape_char)
            $escaped = 1;
          else if (!$escaped && $value[$i] == $enclosure)
            $str2 .= $enclosure;
          else
            $escaped = 0;
          $str2 .= $value[$i];
        }
        $str2 .= $enclosure;
        $str .= $str2.$delimiter;
      }
      else
        $str .= $value.$delimiter;
    }
    $str = substr($str,0,-1);
    $str .= "\n";
    return fwrite($handle, $str);
  }

}

 // Input parameters process
 for ($I=1;$I<$argc;$I++) {
    $C1 = substr($argv[$I],0,1);
    if ($C1=="-") {
        $C2 = substr($argv[$I],1,1);
    	switch ($C2) {
		 	case 'd':
		 	case 'D':
		 		$Drop = 1;
		 		$UseInsert = 1;
		 		break;
		 	case 'e':
		 	case 'E':
		 		$Enc = 1;
		 		include_once('ENCRead.php');
		 		break;
		 	case 'i':
		 	case 'I':
		 		$UseInsert = 1;
		 		break;
		 	case 'n':
		 	case 'N':
		 		$N0Data = 1;
		 		break;
		 	case 'x':
		 	case 'X':
		 		$debug = 1;
		 		break;
	 		default:
		 		echo "Parameter error. >$argv[$I]<.\n";
		 		exit();
	 			break;
    	}	// switch ($C2)
    }  else {	// if ($C1=="-")

		if ($InName=="") {
		 	$InName = $argv[$I];
		 	continue;
		}
		if ($OutName=="") {
		 	$OutName = $argv[$I];
		 	continue;
		}
		if ($LogName=="") {
		 	$LogName = $argv[$I];
		 	continue;
		}
		
		echo "To many input/output files error.\n >$InName, $OutName & $argv[$I]<.\n\n";
		exit();
	}	// if ($C1=="-")

 } // for ($I=1;$I<$argc;$I++)

 //if ($LogName=="") $LogName = "DBToolLog.txt";
 if ($debug) {
 	echo "InName = $InName\n";
	echo "OutName = $OutName\n";
	echo "LogName = $LogName\n";
	echo "Drop = $Drop\n";
	echo "N0Data = $N0Data\n";
	echo "UseInsert = $UseInsert\n";
	echo "DBOut = $DBOut\n";
 }

 //	D.B Tools functions

 if ($Enc) $FileIn = ENCRead($InName);
 else $FileIn = file($InName);

 if (strlen($LogName)!=0) {
	 $LogOut = fopen($LogName, "wt");
	 if (!$LogOut) {
	 	echo "Log file open error.\n";
	 	exit(1);
	 }
 } else $LogOut = 0;

 if ($OutName) {
 		$Fout = fopen($OutName, 'wt');
 		$SubName = strtoupper(substr($OutName,-3));
 		switch ($SubName) {
 			case "CSV":
 				$CSV  = 1;
 				$HTML = 0;
 				$SQL  = 0;
 				break;
 			case "TML":
 			case "HTM":
 				$HTML = 1;
 				$CSV  = 0;
 				$SQL  = 0;
 				break;
 			case "SQL":
 				$SQL  = 1;
 				$CSV  = 0;
 				$HTML = 0;
 				break;
 		}
 		if ($debug) {
			echo "HTML = $HTML\n";
			echo "CSV = $CSV\n";
			echo "SQL = $SQL\n";
 		}
 }

 $PHP_ver = (float) PHP_VERSION;
 if ($debug) echo "PHP Version = $PHP_ver\n";

 // Process first command lines
 $Firstline = 1;
 foreach($FileIn as $line) {
 		// Take out line feed char.
 		$line = chop($line);
 		if ($debug) echo $line."\n";
 		// Skip comment lines
 		if ($line[0]<'A') continue;
 		//
 		//	First line process
 		//
 		if ($Firstline) {
 			$data = split(';',$line);
 			//$data = $data[0];
 			if ($debug) RowList($data);
 			$Firstline = 0;
 			// Ĥ@ӰѼƨS"="ADBType
 			if (stristr($data[0],"=")===false) {
 					$DBType = $data[0];
 					$st = 1;
 			} else $st = 0;
 			// xsĤ@榳ƮwѼ
 			$count = count($data);
 			for ($i=$st;$i<$count;$i++) {
 				$KeyAnVal = split("=",$data[$i]);
 				// Get Key
 				//$Key=strtoupper(stristr($data[$i],"=",true));
 				$Key=strtoupper($KeyAnVal[0]);
 				// Get value, Skip '=' character
 				$Val=substr(stristr($data[$i],"="),1);
 				if ($debug) echo "$i  Key = $Key,  Val = $Val\n";
 				switch ($Key) {
 					case "DBTYPE":
 						$DBType = strtoupper($Val);
 						break;
 					case "SERVER":
 					case "URL":
 						if ($DBType=="ODBC") $URL .= "SERVER=$Val;";
 						else $URL = $Val;
 						$URLX = $Val;
 						break;
 					case "UID":
 					case "USER":
 						$user = $Val;
 						break;
 					case "PW":
 					case "PWD":
 					case "PASS":
 					case "PASSWORD":
 						$pw = $Val;
 						break;

 					case "DATABASE":
 						$DataBase = $Val;
						//if ($DBType=="ODBC") $URL .= "DSN=$Val;";
 						break;

 					case "SID":
 						$SID = $Val;
 						break;

 					case "DBQ":
 						$DBQ = $Val;
 						$URLX = $Val;
 						if ($DBType=="ODBC") {
						 	$URL .= "$Key=$Val;";
 							if (strtolower(substr($Val,-3))=="xls")
						 		 $URL .= "ReadOnly=0;";
						}
 						break;

 					case "DEFAULTDIR":
 					case "DRIVER":
 					case "EXTENSIONS":
 					case "FIL":
 					case "FILEDSN":
 					case "DSN":
 					case "DBA":
 					case "PORT":
 						if ($DBType=="ODBC") $URL .= "$Key=$Val;";
 						break;
 				}
 			}
 			//
 			if ($debug) {
			 	echo "DBType = $DBType\n";
				echo "user = $user\n";
				echo "PW = $pw\n";
				echo "DATABASE = $DataBase\n";
				echo "DBQ = $DBQ\n";
				echo "URL = $URL\n";
				echo "SID = $SID\n";
 			}
 			$DBin=NewDBConnect($DBType,$URL,$user,$pw,$DataBase,$SID);
 			if (!$DBin) {
 				echo "Open $URLX DataBase error.\n";
 				if ($LogOut) fwrite($LogOut,"Open $URLX DataBase error.\n");
 				exit();
 			} else if ($LogOut) fwrite($LogOut,"Open $URLX DataBase O.K..\n");
 			$DBin->debug = 0;
 		} else {	// Non-first line commands
 		//
 		//	All line process
 		//
 			// Select
 			//$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
 			if (strtolower(substr($line,0,6))=="select") {
	 			$recordset = $DBin->Execute($line);
	 			$datax = split('[ ,]', $line);
	 			// print_r ($datax);
				if(!$recordset) {
				 	echo "SQL Command >$datax[0]< execute error.\n";
				 	if ($LogOut) fwrite($LogOut,"SQL Command >$datax[0]< execute error.\n");
				} else {
					if ($LogOut) fwrite($LogOut,"SQL Command >$datax[0]< execute O.K.\n");
					//	For PHP Version 4.X, find out the array row
					if ($PHP_ver<5.0 && !$HTML) {
						foreach($recordset as $row) if (is_array($row)) break;
						$recordset->Close();
						$recordset = $row;
						if ($debug) echo "PHP Version 4.X process.\n";
					}

					// Get Field type
					$Fields = GetTableField($DBin, $DataBase);
					unset ($Type);
					foreach($Fields as $field) {
						//if ($debug) echo "field->type = $field->type\n";
						$Type[] = $field->type;
					}
					if ($debug) {
						for ($i=0;$i<count($Type);$i++) print "Type = ".$Type[$i]."\n";
					}
					unset ($Fields);

					//	Drop and create Process
					if ($Drop && count($recordset)) {
						//echo "Drop loop Drop = $Drop\n";
						$sql = "DROP TABLE $DataBase";
						if ($DBOut) {	// Dump to Data Base
							//	Drop Table
							if ($Drop>0) {
								if(!$DBOut->Execute($sql))
										echo ">$sql< execute error.\n";
										if ($LogOut) fwrite($LogOut,"Drop Table $DataBase error.\n");
							} else if ($LogOut) fwrite($LogOut,"Drop Table $DataBase O.K.\n");
							//	Create Table
							$sql = BuildTableField($DBin,$DataBase);
							if(!$DBOut->Execute($sql)) {
									echo ">$sql< execute error.\n";
									if ($LogOut) fwrite($LogOut,"Create Table $DataBase error.\n");
							} else if ($LogOut) fwrite($LogOut,"Create Table $DataBase O.K.\n");
							//	Build Create TABLE

						} else {		// Dump to file
                      		// Structure Header
                      		$structure = "-- \n";
                      		$structure .= "-- Table structure for table `{$DataBase}` \n";
                      		$structure .= "-- \n\n";
                      		if ($Fout && $SQL) {
                      			fwrite($Fout,$sql."\n");
							    fwrite($Fout,$structure);
                      		} else if (!$Fout) {
                      			echo $sql."\n";
							  	echo $structure;
							}
                      		// Dump Table field in SQL format
                      		$structure = BuildTableField($DBin,$DataBase);
                      		if ($Fout && $SQL) fwrite($Fout,$structure."\n");
                      		else if (!$Fout) echo $structure."\n";
						}
					}
					//	Do not dump data?
					//
					if ($N0Data) continue;

					if (count($recordset)) {
							$KeyName = GetColNames($DBin,$DataBase);
							if ($debug) {
								for ($i=0;$i<count($KeyName);$i++) print "KeyName = ".$KeyName[$i]."\n";
							}
							if ($HTML) {
								if ($Fout) {
									//fwrite($Fout,rs2html($KeyName));
									fputs($Fout,rs2html($recordset,$ztab,'',$specialchars,false));
								} else {
									//echo rs2html($KeyName);
									echo rs2html($recordset,$ztab,'',$specialchars,false);
								}
								continue;
							}
							$header = 1;
							$KeyID = -1;
							$MsgHead = "";

							foreach($recordset as $row) {
								if ($debug) {
									echo "row =\n";
									print_r ($row);
									echo "\n";
								}
								if (count($row)==0) continue;
								//
								//	DataBase output
								//
								if ($DBOut) {
									if ($UseInsert) {	// Insert mode
										if ($MsgHead == "") {
											$MsgHead = "INSERT INTO $OutDataBase (";
											for ($i=0;$i<count($KeyName);$i++) {
												$MsgHead .= $KeyName[$i];
												if ($i!=(count($KeyName)-1)) $MsgHead .= ",";
											}
											$MsgHead .= ") Values (";
										}
										$Msg = $MsgHead;
										for ($i=0;$i<count($row);$i++) {
											if ($Type[$i]=='I') $Msg .= $row[$i];
											else $Msg .= "'".$row[$i]."'";

											if ($i!=(count($row)-1)) $Msg .= ",";
										}
										$Msg .= ")";
									} else {	// Update mode
										if ($KeyID==-1) {	// Find out Key ID
											for ($i=0;$i<count($KeyName);$i++) {
												if ($KeyName[$i]==$OutKey) {
													$KeyID = $i;
													break;
												}
											}
											if ($KeyID == -1) $KeyID = 0;
										}
										$Msg = "UPDATE $OutDataBase SET ";
										for ($i=0;$i<count($row);$i++) {
											if ($i==$KeyID) continue;
											if ($Type[$i]=='I') $Msg .= $KeyName[$i].'='.$row[$i];
											else $Msg .= $KeyName[$i]."='".$row[$i]."'";
											if ($i!=(count($row)-1)) $Msg .= ",";
										}
										$Msg .= " Where ";
										if ($Type[$KeyID]=='I') $Msg .= $KeyName[$KeyID].'='.$row[$KeyID];
										else $Msg .= $KeyName[$KeyID]."='".$row[$KeyID]."'";
									}
									if ($debug) echo "SQL Execute->$Msg\n";
									$datax = split('[ ,]', $Msg);
						 			if(!$DBOut->Execute($Msg)) {
									 	echo "SQL Command >$datax[0]< execute error.\n";
									 	if ($LogOut) fwrite($LogOut,"SQL Command >$datax[0]< execute error.\n");
									} else if ($LogOut) fwrite($LogOut,"SQL Command >$datax[0]< execute O.K.\n");
									continue;
								}
								//
								//	Non-DataBase output
								//
								// List column name(First line)
								if ($header) {
									$header = 0;

									if ($OutName) {
										if ($CSV) {
											fputcsv($Fout,$KeyName);
										}
									} else RowList($KeyName);
									//fputcsv($fp,$k);
								}	// List all data here.
								if ($OutName) {
									if ($CSV) {
										fputcsv($Fout,$row);
										continue;
									}
									//	SQL mode
									//
									if ($UseInsert) {	// Insert mode
										if ($MsgHead == "") {
											$MsgHead = "INSERT INTO $DataBase (";
											for ($i=0;$i<count($KeyName);$i++) {
												$MsgHead .= $KeyName[$i];
												if ($i!=(count($KeyName)-1)) $MsgHead .= ",";
											}
											$MsgHead .= ") Values (";
										}
										$Msg = $MsgHead;
										for ($i=0;$i<count($row);$i++) {
											if ($Type[$i]=='I') $Msg .= $row[$i];
											else $Msg .= '"'.$row[$i].'"';

											if ($i!=(count($row)-1)) $Msg .= ",";
										}
										$Msg .= ")";
									} else {	// Update mode
										if ($KeyID==-1) {	// Find out Key ID
											for ($i=0;$i<count($KeyName);$i++) {
												if ($KeyName[$i]==$OutKey) {
													$KeyID = $i;
													break;
												}
											}
											if ($KeyID == -1) $KeyID = 0;
										}
										$Msg = "UPDATE $DataBase SET ";
										for ($i=0;$i<count($row);$i++) {
											if ($i==$KeyID) continue;
											if ($Type[$i]=='I') $Msg .= $KeyName[$i].'='.$row[$i];
											else $Msg .= $KeyName[$i].'="'.$row[$i].'"';
											if ($i!=(count($row)-1)) $Msg .= ",";
										}
										$Msg .= " Where ";
										if ($Type[$KeyID]=='I') $Msg .= $KeyName[$KeyID].'='.$row[$KeyID];
										else $Msg .= $KeyName[$KeyID].'="'.$row[$KeyID].'"';
									}
									if ($debug) echo "fwrite->$Msg\n";
									fwrite($Fout,$Msg."\n");
									continue;
								} else {
									RowList($row);
								}
							}
					}
					if (!(PHP_ver<5.0 && !$HTML)) $recordset->Close();
				}
 				continue;
 			}	// End of Select

 			// DBout
 			if (strtolower(substr($line,0,5))=="dbout") {
	 			$data = split(';',substr($line,6));
	 			// Ĥ@ӰѼƨS"="ADBType
	 			if (stristr($data[0],"=")===false) {
	 					$OutDBType = $data[0];
	 					$st = 1;
	 			} else $st = 0;
	 			// xsƮwѼ
	 			$count = count($data);
	 			for ($i=$st;$i<$count;$i++) {
	 				$KeyAnVal = split("=",$data[$i]);
	 				// Get Key
	 				//$Key=strtoupper(stristr($data[$i],"=",true));
	 				$Key=strtoupper($KeyAnVal[0]);
	 				// Get value, Skip '=' character
	 				$Val=substr(stristr($data[$i],"="),1);
	 				if ($debug) echo "$i  Key = $Key,  Val = $Val\n";
	 				if ($Val) switch ($Key) {
	 					case "DBTYPE":
	 						$OutDBType = $Val;
	 						break;
	 					case "SERVER":
	 					case "URL":
	 						if ($OutDBType=="ODBC") $OutURL .= "SERVER=$Val;";
	 						else $OutURL .= "SERVER=$Val;";
	 						$OutURLX = $Val;
	 						break;
	 					case "UID":
	 					case "USER":
	 						$Outuser = $Val;
	 						break;
	 					case "PW":
	 					case "PWD":
	 					case "PASS":
	 					case "PASSWORD":
	 						$Outpw = $Val;
	 						break;

	 					case "DATABASE":
	 						$OutDataBase = $Val;
							//if ($DBType=="ODBC") $OutURL .= "DSN=$Val;";
	 						break;

	 					case "SID":
	 						$OutSID = $Val;
	 						break;

	 					case "DBQ":
	 						if ($OutDBType=="ODBC") {
							 	$OutURL .= "$Key=$Val;";
							 	$OutURLX = $Val;
	 							if (strtolower(substr($Val,-3))=="xls") {
							 		 $OutURL .= "ReadOnly=0;FIL=excel 8.0;";
							 		 $Drop = 0;
							 		 $UseInsert = 1;
							 		 $Excel = 1;
							 	} else $Excel = 0;
							}
	 						break;

	 					case "DEFAULTDIR":
	 					case "DRIVER":
	 					case "EXTENSIONS":
	 					case "FIL":
	 					case "FILEDSN":
	 					case "DSN":
	 					case "DBA":
	 					case "PORT":
	 						if ($OutDBType=="ODBC") $OutURL .= "$Key=$Val;";
	 						break;
	 				} else {
	 					/*
	 					case "DROP":
		 					$UseInsert = 1;
		 					$Drop = 1;
	 						break;
	 					case "INSERT":
		 					$UseInsert = 1;
		 					$Drop = 0;
	 						break;
	 					*/
	 					//
	 					//	Rest of the parameters
	 					//
	 					$datax = (Parse($Key));
	 					if ($debug) RowList ($datax);
		 				// process Insert/Update/Drop flag
		 				$c = $datax[0][0];
		 				if ($c=='d' || $c=='D') {
		 					$UseInsert = 1;
		 					if (!$Excel) $Drop = 1;
		 				} else if ($c=='i' || $c=='I') {
		 					$UseInsert = 1;
		 					$Drop = 0;
		 				} else {
						 	$UseInsert = 0;
						 	$Drop = 0;
						}
		 				// Porcess data table name
		 				$OutDataBase = $datax[1];
		 				// process Key name
		 				$OutKey = $datax[2];
		 				//goto DBout001;	// Stop looping
	 				}	// $Val = '', last one will be all non-D.B. parameters.
	 			}
	 			//
//DBout001:
	 			if ($debug) {
				 	echo "OutDBType = $OutDBType\n";
					echo "Outuser = $Outuser\n";
					echo "OutPW = $Outpw\n";
					echo "OutDATABASE = $OutDataBase\n";
					echo "OutDBQ = $OutDBQ\n";
					echo "OutURL = $OutURL\n";
					echo "OutSID = $OutSID\n";
					echo "OutKey = $OutKey\n";
					echo "UseInsert = $UseInsert\n";
	 			}
	 			$DBOut=NewDBConnect($OutDBType,$OutURL,$Outuser,$Outpw,$OutBataBase,$OutSID);
	 			if (!$DBOut) {
	 				echo "Open $OutURLX DataBase error.\n";
	 				if ($LogOut) fwrite($LogOut,"Open $OutURLX DataBase error.\n");
	 				exit();
	 			} else if ($LogOut) fwrite($LogOut,"Open $OutURLX DataBase O.K.\n");
	 			$DBOut->debug = 0;
 				continue;
 			}	// end of DBout

 			// Excel
 			if (strtolower(substr($line,0,5))=="excel") {
 				if ($DBOut) $DBOut->close();
 				unset ($DBOut);
 				$OutDBType = 'ODBC';
 				$OutURL = "Driver={Driver do Microsoft Excel(*.xls)};ReadOnly=0;FIL=excel 8.0;";
 				$Outuser = "admin";
 				$UseInsert = 1;
 				$Drop = 0;
 				$datax = Parse($line);
 				//	process file name
 				$OutURL .= "DBQ=".$datax[1];
 				// process Insert/Update/Drop flag
 				/*
 				$c = $datax[2][0];
 				if ($c=='c' || $c=='C') {
 					$UseInsert = 1;
 					$Drop = -1;
 				} else if ($c=='i' || $c=='I') {
 					$UseInsert = 1;
 					$Drop = 0;
 				} else {
				 	$UseInsert = 0;
				 	$Drop = 0;
				}
				*/
 				// Porcess data sheet name
 				//$OutDataBase = $datax[3];
 				$OutDataBase = $datax[2];
 				// process Key name
 				//$OutKey = $datax[4];
 				$OutKey = $datax[3];

	 			if ($debug) {
				 	echo "OutDBType = $OutDBType\n";
					echo "Outuser = $Outuser\n";
					echo "OutPW = $Outpw\n";
					echo "OutDATABASE = $OutDataBase\n";
					echo "OutDBQ = $OutDBQ\n";
					echo "OutURL = $OutURL\n";
					echo "OutSID = $OutSID\n";
					echo "OutKey = $OutKey\n";
					echo "UseInsert = $UseInsert\n";
	 			}

	 			$DBOut=NewDBConnect($OutDBType,$OutURL,$Outuser,$Outpw,$OutBataBase,$OutSID);
	 			if (!$DBOut) {
	 				echo "Open $datax[1] DataBase error.\n";
	 				if ($LogOut) fwrite($LogOut,"Open $datax[1] DataBase error.\n");
	 				exit();
	 			} else if ($LogOut) fwrite($LogOut,"Open $datax[1] DataBase O.K.\n");
	 			$DBOut->debug = 0;
 				continue;
 			}

 			// HTML
 			if (strtolower(substr($line,0,4))=="html") {
 				$HTML = 1;
				$data = split(';',$line);

				if ($data[1][0]) $ztab = $data[1];
				if ($data[2][0]) {
					if ($data[2][0]=='t' ||
					    $data[2][0]=='T') $specialchars = true;
					else $specialchars = false;
				}
				if ($LogOut) fwrite($LogOut,"Set HTML.\n");
 				continue;
 			}

 			// List D.B. Tables
 			if (strtolower($line)=="listdbtables") {
				print ("Database Name: $DataBase.\n============================\n");
				ListDBTables($DBin);
				if ($LogOut) fwrite($LogOut,"ListDBTables complete.\n");
 				continue;
 			}

 			// Define DataBase
 			if (strtolower(substr($line,0,8))=="database") {
 				//list($data,$DataBase) = split("[,; \t=]",$line);
 				$data = Parse($line);
 				$DataBase = $data[1];
 				// print_r ($data);
 				// echo "DataBase = $DataBase\n";
 				if ($LogOut) fwrite($LogOut,"Set DataBase name.\n");
 				continue;
 			}

 			// Direct Execute SQL Command
 			if(!$DBin->Execute($line)) {
 				$datax = split('[ ,]', $line);
			 	echo "SQL Command >$datax[0]< execute error.\n";
			 	if ($LogOut) fwrite($LogOut,"SQL Command >$datax[0]< execute error.\n");
			} else if ($LogOut) fwrite($LogOut,"SQL Command >$datax[0]< execute O.K.\n");
 		}
 }



 //
 //	Exit
 //
	$DBin->close();
	if ($DBOut) $DBOut->close();
	if ($Fout) fclose($Fout);
	if ($LogOut) fclose($LogOut);
//
//
//
function Parse($line) {
	$data = array();

	$i = 0;
	$count = strlen($line);
	// print "count = $count\n";
	if (!$count) return null;

	for ($j=0;$j<$count;$j++) {
		$c = $line[$j];
		// print "c = $c\n";
		if ($c !=" " &&
		    $c !="\t" &&
		    $c !=";" &&
			$c !=",") $data[$i] .= $line[$j];
		else if ($data[$i]) $i++;
	}
	return $data;
}

?>
